// Any Device - Utilities - Win64 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/common/utils/win64/gsc_os_util.h $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#ifndef __GSC_OS_UTIL_H__
#define __GSC_OS_UTIL_H__

#include "gsc_common.h"



/* typedefs	*****************************************************************/

typedef enum
{
	GSC_OS_SEM_GET_OK,
	GSC_OS_SEM_GET_TO,
	GSC_OS_SEM_GET_ER
} gsc_os_sem_get_t;

typedef struct
{
	HANDLE	handle;
} gsc_os_sem_t;

typedef struct
{
	HANDLE	handle;
} gsc_os_thread_t;



/* prototypes	*************************************************************/

int		gsc_os_id_host(void);
int		gsc_os_id_os_issue(void);
//int		gsc_os_ini_bool_get(const char* file, const char* section, const char* key, int* value, int defalt);
//void	gsc_os_ini_bool_set(const char* file, const char* section, const char* key, int value);
void	gsc_os_ini_init(const char* base_name);
int		gsc_os_ini_int_get(const char* file, const char* section, const char* key, int* value, int defalt);
void	gsc_os_ini_int_set(const char* file, const char* section, const char* key, int value);
int		gsc_os_ini_str_get(const char* file, const char* section, const char* key, char* value, size_t size);
void	gsc_os_ini_str_set(const char* file, const char* section, const char* key, const char* value);
//int		gsc_os_ini_u32_get(const char* file, const char* section, const char* key, U32* value, U32 defalt);
//void	gsc_os_ini_u32_set(const char* file, const char* section, const char* key, U32 value);

int		gsc_os_thread_create(gsc_os_thread_t* thread, U32 (*function)(void* arg), void* arg);
//int		gsc_os_thread_destroy(gsc_os_thread_t* thread);

int		gsc_os_sem_create(gsc_os_sem_t* sem);
int		gsc_os_sem_create_qty(gsc_os_sem_t* sem, int cap, int put);
int		gsc_os_sem_destroy(gsc_os_sem_t* sem);
int		gsc_os_sem_put(gsc_os_sem_t* sem);
int		gsc_os_sem_put_qty(gsc_os_sem_t* sem, int put);

void	gsc_os_sleep_ms(long ms);

U32		gsc_os_time_delta_ms(void);

gsc_os_sem_get_t	gsc_os_sem_get(gsc_os_sem_t* sem);
gsc_os_sem_get_t	gsc_os_sem_get_to(gsc_os_sem_t* sem, int timeout_ms);	// < 0 = forever



#endif
