// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/ringbuf/win32/gui_buf_type.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <windows.h>
#include <stdio.h>

#include "gui.h"
#include "resource.h"
#include "hpdi32_util.h"
#include "gsc_util.h"



/* #defines	*****************************************************************/

#define	KEY				"Buffer Type"
#define	BUFFER_TYPE_API	0
#define	BUFFER_TYPE_APP	1



/* variables	*************************************************************/

static	HWND	_buf_type_app;
static	HWND	_buf_type_api;
static	int		_setting;



/*****************************************************************************
*
*	Function:	_update_and_save
*
*	Purpose:
*
*		Update the menu check state and save the setting.
*
*	Arguments:
*
*		value	The current setting.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

static void _update_and_save(int value)
{
	if (value == BUFFER_TYPE_API)
	{
		_setting	= BUFFER_TYPE_API;
		gui.api_buf	= TRUE;
		SendMessage(_buf_type_api, BM_SETCHECK, BST_CHECKED, 0);
		SendMessage(_buf_type_app, BM_SETCHECK, BST_UNCHECKED, 0);
	}
	else
	{
		_setting	= BUFFER_TYPE_APP;
		gui.api_buf	= FALSE;
		SendMessage(_buf_type_api, BM_SETCHECK, BST_UNCHECKED, 0);
		SendMessage(_buf_type_app, BM_SETCHECK, BST_CHECKED, 0);
	}

	gsc_os_ini_int_set(NULL, NULL, KEY, _setting);
}



/*****************************************************************************
*
*	Function:	buffer_type_init
*
*	Purpose:
*
*		Initialize things for the Buffer Type option.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void buffer_type_init(void)
{
	int		i;

	_buf_type_api	= GetDlgItem(gui.dlg, IDC_BUF_TYPE_API);
	_buf_type_app	= GetDlgItem(gui.dlg, IDC_BUF_TYPE_APP);
	gsc_os_ini_int_get(NULL, NULL, KEY, &i, BUFFER_TYPE_APP);
	_update_and_save(i);
}



/*****************************************************************************
*
*	Function:	buffer_type_refresh
*
*	Purpose:
*
*		Refresh the buffer type controls.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void buffer_type_refresh(void)
{
	EnableWindow(_buf_type_app, !gui.working);
	SendMessage(_buf_type_app, WM_PAINT, 0, 0);

	EnableWindow(_buf_type_api, !gui.working);
	SendMessage(_buf_type_api, WM_PAINT, 0, 0);
}



/*****************************************************************************
*
*	Function:	buffer_type_wm_command
*
*	Purpose:
*
*		Process a WM_COMMAND message for a Buffer Type controls.
*
*	Arguments:
*
*		id		The id of the control or menu item selected.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void buffer_type_wm_command(int id)
{
	switch (id)
	{
		default:
		case IDC_BUF_TYPE_API:

			id	= BUFFER_TYPE_API;
			break;

		case IDC_BUF_TYPE_APP:

			id	= BUFFER_TYPE_APP;
			break;
	}

	_update_and_save(id);
}


