// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/ringbuf/win32/gui_stop.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <windows.h>
#include <stdio.h>
#include <time.h>

#include "gui.h"
#include "proc.h"
#include "resource.h"
#include "gsc_util.h"



/* variables	*************************************************************/

static	HANDLE		_control;



/*****************************************************************************
*
*	Function:	stop_init
*
*	Purpose:
*
*		Initialize things for the STOP button.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void stop_init(void)
{
	_control	= GetDlgItem(gui.dlg, IDC_STOP);
}



/*****************************************************************************
*
*	Function:	stop_refresh
*
*	Purpose:
*
*		Refresh the STOP button.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void stop_refresh(void)
{
	int	enabled;

	if ((!gui.working) || (gui.stop_req))
	{
		EnableWindow(_control, FALSE);
	}
	else
	{
		enabled	= IsWindowEnabled(_control);
		EnableWindow(_control, TRUE);

		if (!enabled)
			SetFocus(_control);
	}

	SendMessage(_control, WM_PAINT, 0, 0);
}



/*****************************************************************************
*
*	Function:	stop_wm_command
*
*	Purpose:
*
*		Process WM_COMMAND messages for the STOP button.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void stop_wm_command(void)
{
	const char*	psz;
	struct tm*	stm;
	time_t		tt;

	process_stop();
	gui.stop_req	= TRUE;
	gsc_label_text("Stop Request");
	time(&tt);
	stm	= localtime(&tt);
	psz	= asctime(stm);
	printf("%s", psz);
}


