// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/ringbuf/win32/gui_tx_operation.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <windows.h>
#include <stdio.h>

#include "gui.h"
#include "proc.h"
#include "resource.h"
#include "hpdi32_util.h"
#include "gsc_util.h"



/* #defines	*****************************************************************/

#define	KEY			"Tx Operation"



/* variables	*************************************************************/

static	HMENU		_menu;
static	const char*	_name;



/*****************************************************************************
*
*	Function:	_update_and_save
*
*	Purpose:
*
*		Update the menu check state and save the setting.
*
*	Arguments:
*
*		value	The current setting.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

static void _update_and_save(int value)
{
	switch (value)
	{
		default:
		case TX_OP_DISCARD:

			_name		= "Discard";
			gui.tx_op	= TX_OP_DISCARD;
			CheckMenuItem(_menu, IDC_TX_OP_DISCARD, MF_BYCOMMAND | MF_CHECKED);
			CheckMenuItem(_menu, IDC_TX_OP_XMIT, MF_BYCOMMAND | MF_UNCHECKED);
			CheckMenuItem(_menu, IDC_TX_OP_SAVE, MF_BYCOMMAND | MF_UNCHECKED);
			break;

		case TX_OP_XMIT:

			_name		= "Transmit";
			gui.tx_op	= TX_OP_XMIT;
			CheckMenuItem(_menu, IDC_TX_OP_DISCARD, MF_BYCOMMAND | MF_UNCHECKED);
			CheckMenuItem(_menu, IDC_TX_OP_XMIT, MF_BYCOMMAND | MF_CHECKED);
			CheckMenuItem(_menu, IDC_TX_OP_SAVE, MF_BYCOMMAND | MF_UNCHECKED);
			break;

		case TX_OP_SAVE:

			_name		= "Save";
			gui.tx_op	= TX_OP_SAVE;
			CheckMenuItem(_menu, IDC_TX_OP_DISCARD, MF_BYCOMMAND | MF_UNCHECKED);
			CheckMenuItem(_menu, IDC_TX_OP_XMIT, MF_BYCOMMAND | MF_UNCHECKED);
			CheckMenuItem(_menu, IDC_TX_OP_SAVE, MF_BYCOMMAND | MF_CHECKED);
			break;
	}

	gui_menu_add_text(_menu, _name);
	gsc_os_ini_int_set(NULL, NULL, KEY, gui.tx_op);
}



/*****************************************************************************
*
*	Function:	tx_operation_init
*
*	Purpose:
*
*		Initialize things for the Tx Operation option.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void tx_operation_init(void)
{
	int		i;

	_menu	= GetMenu(gui.dlg);
	_menu	= gui_menu_locate_parent_by_id(_menu, IDC_TX_OP_DISCARD);
	gsc_os_ini_int_get(NULL, NULL, KEY, &i, TX_OP_DISCARD);
	_update_and_save(i);
}



/*****************************************************************************
*
*	Function:	tx_operation_refresh
*
*	Purpose:
*
*		Refresh the Tx Operation menu items.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void tx_operation_refresh(void)
{
	if (gui.working)
	{
		EnableMenuItem(_menu, IDC_TX_OP_DISCARD, MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(_menu, IDC_TX_OP_XMIT, MF_BYCOMMAND | MF_GRAYED);
		EnableMenuItem(_menu, IDC_TX_OP_SAVE, MF_BYCOMMAND | MF_GRAYED);
	}
	else
	{
		EnableMenuItem(_menu, IDC_TX_OP_DISCARD, MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(_menu, IDC_TX_OP_XMIT, MF_BYCOMMAND | MF_ENABLED);
		EnableMenuItem(_menu, IDC_TX_OP_SAVE, MF_BYCOMMAND | MF_ENABLED);
	}
}



/*****************************************************************************
*
*	Function:	tx_operation_wm_command
*
*	Purpose:
*
*		Process a WM_COMMAND message for a Tx Operation control or
*		menu items.
*
*	Arguments:
*
*		id		The id of the control or menu item selected.
*
*	Returned:
*
*		None.
*
*****************************************************************************/

void tx_operation_wm_command(int id)
{
	switch (id)
	{
		default:
		case IDC_TX_OP_DISCARD:

			id	= TX_OP_DISCARD;
			break;

		case IDC_TX_OP_XMIT:

			id	= TX_OP_XMIT;
			break;

		case IDC_TX_OP_SAVE:

			id	= TX_OP_SAVE;
			break;
	}

	_update_and_save(id);
}


