// HPDI32 - Utilities - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/utils/util_count.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <stdio.h>

#include "hpdi32_util.h"
#include "hpdi32_dsl.h"



/*****************************************************************************
*
*	Function:	dev_board_count
*
*	Purpose:
*
*		Count the number of installed HPDI32 boards.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		>= 0	The number of boards found.
*		< 0		The number of errors encounterred here.
*
*****************************************************************************/

int dev_board_count(void)
{
	U8	count;
	int	errs;
	int	ret;
	U32	status;

	gsc_label_text("HPDI32 Board Count");
	status	= hpdi32_board_count(&count);
	errs	= label_fail_func(1, "hpdi32_board_count", status);

	if (errs)
	{
		ret	= -1;
	}
	else if (count == 0)
	{
		ret	= 0;
		printf("No boards found\n");
	}
	else
	{
		ret	= (int) count;
		printf("%d\n", ret);
	}

	return(ret);
}


