// HPDI32 - Utilities - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/utils/util_open.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

#include <stdio.h>

#include "hpdi32_util.h"
#include "hpdi32_dsl.h"



/*****************************************************************************
*
*	Function:	dev_open
*
*	Purpose:
*
*		Implement a wrapper around the similarly named HPDI32 function.
*
*	Arguments:
*
*		index	The index of the board to open.
*
*		dev		The device handle is recorded here.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
*****************************************************************************/

int dev_open(U8 index, void** dev)
{
	char	buf[64];
	int		errs	= 0;
	U32		status;

	sprintf(buf, "Opening HPDI32 #%d", (int) index);
	gsc_label_text(buf);
	status	= hpdi32_open(index, dev);
	errs	= label_fail_func(1, "hpdi32_open", status);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


