// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/config.h $
// $Rev: 2902 $
// $Date: 2009-08-09 17:48:49 -0500 (Sun, 09 Aug 2009) $

/*****************************************************************************
*
*	Export items for the Configuration services.
*
*****************************************************************************/

#ifndef __CONFIG_H__
#define	__CONFIG_H__

#include "service.h"	/*lint !e537 */



/* typedefs	*****************************************************************/

typedef enum
{
	TYPE_PARM_LIST,	// config_item_t.vp points to config_parm_list_t.
	TYPE_PROGRESS,
	TYPE_TEXT
} config_type_t;

typedef struct
{
	const char*		title;
	const char*		desc;
	config_type_t	type;
	void*			vp;
} config_item_t;

typedef struct
{
	const char*			title;
	const char*			prefix;
	const parm_list_t*	list;
} config_parm_list_t;

typedef struct
{
	int	misc;
	int	cable;
	int	tx;
	int	rx;
} config_progress_t;



/* prototypes	*************************************************************/

void	config_list_retrieve(const config_item_t** list, size_t* size);

LRESULT	config_restore_service(		HWND			dlg,
									device_t*		device,
									service_type_t	service,
									WPARAM			wParam,
									LPARAM			lParam);

LRESULT	config_save_service(		HWND			dlg,
									device_t*		device,
									service_type_t	service,
									WPARAM			wParam,
									LPARAM			lParam);

void	config_show_entry_c_code(	HWND					dlg,
									device_t*				device,
									const config_item_t*	list,
									size_t					size,
									char*					dest);

LRESULT	config_wizard_service(		HWND			dlg,
									device_t*		device,
									service_type_t	service,
									WPARAM			wParam,
									LPARAM			lParam);



#endif
