// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/gui.h $
// $Rev: 31452 $
// $Date: 2014-11-13 09:58:59 -0600 (Thu, 13 Nov 2014) $

/*****************************************************************************
*
*	Export items for the GUI dialog.
*
*****************************************************************************/

#ifndef __GUI_H__
#define	__GUI_H__

#include "service.h"		/*lint !e537 */


// #defines	*******************************************************************

#if defined(_M_X64)

#ifndef __GNUC__
	#define	stricmp						_stricmp
#endif

	#define	THREAD_T					uintptr_t

	#define	GET_WINDOW_USER_DATA(w)		GetWindowLongPtr((w),GWLP_USERDATA)
	#define	SET_WINDOW_USER_DATA(w,v)	SetWindowLongPtr((w),GWLP_USERDATA,(LONG_PTR)(v))

	#define	SET_WINDOW_WND_PROC(w,v)	SetWindowLongPtr((w),GWLP_WNDPROC,(LONG_PTR)(v))

#elif defined(WIN32)


	#if (_MSC_VER >= 1400)	// Visual Studio 2005 or later
		#define	stricmp	_stricmp
	#endif

	#define	THREAD_T					DWORD

	#define	GET_WINDOW_USER_DATA(w)		GetWindowLong((w),GWL_USERDATA)
	#define	SET_WINDOW_USER_DATA(w,v)	SetWindowLong((w),GWL_USERDATA,(long)(v))

	#define	SET_WINDOW_WND_PROC(w,v)	SetWindowLong((w),GWL_WNDPROC,(long)(v))

#endif

#ifndef _MAX_PATH
#define _MAX_PATH   1024
#endif



/* prototypes	*************************************************************/

LRESULT	gui_service(HWND			dlg,
					device_t*		device,
					service_type_t	service,
					WPARAM			wParam,
					LPARAM			lParam);



#endif
