// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/io.h $
// $Rev: 2902 $
// $Date: 2009-08-09 17:48:49 -0500 (Sun, 09 Aug 2009) $

/*****************************************************************************
*
*	Export items for common I/O processing.
*
*****************************************************************************/

#ifndef __IO_H__
#define	__IO_H__

#include "service.h"		/*lint !e537 */



/* typedefs	*****************************************************************/

typedef struct
{
	HWND	control;	// Used for monitoring changes.
	U32		defalt;		// MUST BE SET BY CODE WANTING THE DIALOG!
	int		ignore;		// Ignore change activity?
	U32		setting;	// The device/dialog setting is recorded here.
} _io_t;

typedef struct
{
	// These are filled in by the code wanting the window opened.
	device_t*	device;
	const char*	section_name;
	const char*	title;
	U32			which;
	int			id_button;	// The id of the button that invokes the I/O dialog.

	// These are filled in by the code maintaining the window.
	_io_t		api_buf_size;
	_io_t		app_buf;
	U32			bus_size;
	int			changes;	// Are there changes to apply?
	_io_t		data_size;
	HWND		dlg;
	_io_t		dma_ch_sel;
	_io_t		dma_ctrl_mode;
	_io_t		dma_pri;
	_io_t		mode;
	_io_t		pio_threshold;
	_io_t		single_cycle;
	U32			single_cycle_disable;
	_io_t		timeout;
	int			was_open;
} io_data_t;



/* variables	*************************************************************/

extern	const parm_entry_t*	io_parm_api_buffer_list[2];
extern	const parm_entry_t*	io_parm_list[9];



/* prototypes	*************************************************************/

LRESULT	io_service(	HWND			dlg,
					device_t*		device,
					service_type_t	service,
					WPARAM			arg1,
					LPARAM			arg2);



#endif
