// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/regs_fw_bsr.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

/*****************************************************************************
*
*	Provide data describing the Board Status Register.
*
*****************************************************************************/

#include "regs.h"



/* variables	*************************************************************/

static const reg_value_t	_bj0_values[]	=
{
	{
	/* name		*/	"Off",
	/* value	*/	0
	},
	{
	/* name		*/	"On",
	/* value	*/	HPDI32_BSR_BJ0
	}
};

static const reg_value_t	_bj1_values[]	=
{
	{
	/* name		*/	"Off",
	/* value	*/	0
	},
	{
	/* name		*/	"On",
	/* value	*/	HPDI32_BSR_BJ1
	}
};

static const reg_value_t	_d0_values[]	=
{
	{
	/* name		*/	"Low",
	/* value	*/	0
	},
	{
	/* name		*/	"high",
	/* value	*/	HPDI32_BSR_D0
	}
};

static const reg_value_t	_d1_values[]	=
{
	{
	/* name		*/	"Low",
	/* value	*/	0
	},
	{
	/* name		*/	"high",
	/* value	*/	HPDI32_BSR_D1
	}
};

static const reg_value_t	_d2_values[]	=
{
	{
	/* name		*/	"Low",
	/* value	*/	0
	},
	{
	/* name		*/	"high",
	/* value	*/	HPDI32_BSR_D2
	}
};

static const reg_value_t	_d3_values[]	=
{
	{
	/* name		*/	"Low",
	/* value	*/	0
	},
	{
	/* name		*/	"high",
	/* value	*/	HPDI32_BSR_D3
	}
};

static const reg_value_t	_d4_values[]	=
{
	{
	/* name		*/	"Low",
	/* value	*/	0
	},
	{
	/* name		*/	"high",
	/* value	*/	HPDI32_BSR_D4
	}
};

static const reg_value_t	_d5_values[]	=
{
	{
	/* name		*/	"Low",
	/* value	*/	0
	},
	{
	/* name		*/	"high",
	/* value	*/	HPDI32_BSR_D5
	}
};

static const reg_value_t	_d6_values[]	=
{
	{
	/* name		*/	"Low",
	/* value	*/	0
	},
	{
	/* name		*/	"high",
	/* value	*/	HPDI32_BSR_D6
	}
};

static const reg_value_t	_pecl_values[]	=
{
	{
	/* name		*/	"No",
	/* value	*/	0
	},
	{
	/* name		*/	"Yes",
	/* value	*/	HPDI32_BSR_PECL
	}
};

static const reg_value_t	_rx_fifo_values[]	=
{
	{
	/* name		*/	"Full",
	/* value	*/	HPDI32_BSR_RX_NOT_AE |
					HPDI32_BSR_RX_NOT_EMPTY
	},
	{
	/* name		*/	"Almost Full",
	/* value	*/	HPDI32_BSR_RX_NOT_FULL |
					HPDI32_BSR_RX_NOT_AE |
					HPDI32_BSR_RX_NOT_EMPTY
	},
	{
	/* name		*/	"Median",
	/* value	*/	HPDI32_BSR_RX_NOT_FULL |
					HPDI32_BSR_RX_NOT_AF |
					HPDI32_BSR_RX_NOT_AE |
					HPDI32_BSR_RX_NOT_EMPTY
	},
	{
	/* name		*/	"Almost Empty",
	/* value	*/	HPDI32_BSR_RX_NOT_FULL |
					HPDI32_BSR_RX_NOT_AF |
					HPDI32_BSR_RX_NOT_EMPTY
	},
	{
	/* name		*/	"Empty",
	/* value	*/	HPDI32_BSR_RX_NOT_FULL |
					HPDI32_BSR_RX_NOT_AF
	}
};

static const reg_value_t	_rxae_values[]	=
{
	{
	/* name		*/	"Almost Empty",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Almost Empty",
	/* value	*/	HPDI32_BSR_RX_NOT_AE
	}
};

static const reg_value_t	_rxaf_values[]	=
{
	{
	/* name		*/	"Almost Full",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Almost Full",
	/* value	*/	HPDI32_BSR_RX_NOT_AF
	}
};

static const reg_value_t	_rxe_values[]	=
{
	{
	/* name		*/	"Empty",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Empty",
	/* value	*/	HPDI32_BSR_RX_NOT_EMPTY
	}
};

static const reg_value_t	_rxf_values[]	=
{
	{
	/* name		*/	"Full",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Full",
	/* value	*/	HPDI32_BSR_RX_NOT_FULL
	}
};

static const reg_value_t	_rxor_values[]	=
{
	{
	/* name		*/	"No",
	/* value	*/	0
	},
	{
	/* name		*/	"Yes",
	/* value	*/	HPDI32_BSR_RX_OVERRUN
	}
};

static const reg_value_t	_rxur_values[]	=
{
	{
	/* name		*/	"No",
	/* value	*/	0
	},
	{
	/* name		*/	"Yes",
	/* value	*/	HPDI32_BSR_RX_UNDER_RUN
	}
};

static const reg_value_t	_tx_fifo_values[]	=
{
	{
	/* name		*/	"Full",
	/* value	*/	HPDI32_BSR_TX_NOT_AE |
					HPDI32_BSR_TX_NOT_EMPTY
	},
	{
	/* name		*/	"Almost Full",
	/* value	*/	HPDI32_BSR_TX_NOT_FULL |
					HPDI32_BSR_TX_NOT_AE |
					HPDI32_BSR_TX_NOT_EMPTY
	},
	{
	/* name		*/	"Median",
	/* value	*/	HPDI32_BSR_TX_NOT_FULL |
					HPDI32_BSR_TX_NOT_AF |
					HPDI32_BSR_TX_NOT_AE |
					HPDI32_BSR_TX_NOT_EMPTY
	},
	{
	/* name		*/	"Almost Empty",
	/* value	*/	HPDI32_BSR_TX_NOT_FULL |
					HPDI32_BSR_TX_NOT_AF |
					HPDI32_BSR_TX_NOT_EMPTY
	},
	{
	/* name		*/	"Empty",
	/* value	*/	HPDI32_BSR_TX_NOT_FULL |
					HPDI32_BSR_TX_NOT_AF
	}
};

static const reg_value_t	_txa_values[]	=
{
	{
	/* name		*/	"Inactive",
	/* value	*/	0
	},
	{
	/* name		*/	"Active",
	/* value	*/	HPDI32_BSR_TX_ACTIVE
	}
};

static const reg_value_t	_txae_values[]	=
{
	{
	/* name		*/	"Almost Empty",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Almost Empty",
	/* value	*/	HPDI32_BSR_TX_NOT_AE
	}
};

static const reg_value_t	_txaf_values[]	=
{
	{
	/* name		*/	"Almost Full",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Almost Full",
	/* value	*/	HPDI32_BSR_TX_NOT_AF
	}
};

static const reg_value_t	_txe_values[]	=
{
	{
	/* name		*/	"Empty",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Empty",
	/* value	*/	HPDI32_BSR_TX_NOT_EMPTY
	}
};

static const reg_value_t	_txf_values[]	=
{
	{
	/* name		*/	"Full",
	/* value	*/	0
	},
	{
	/* name		*/	"Not Full",
	/* value	*/	HPDI32_BSR_TX_NOT_FULL
	}
};

static const reg_value_t	_txor_values[]	=
{
	{
	/* name		*/	"No",
	/* value	*/	0
	},
	{
	/* name		*/	"Yes",
	/* value	*/	HPDI32_BSR_TX_OVERRUN
	}
};

static reg_field_t	_bsr_fields[]	=
{
	{
	/* name		*/	"RES",
	/* desc		*/	"Reserved",
	/* mask		*/	0xFF000000,
	/* value	*/	NULL,
	/* values	*/	0
	},
	{
	/* name		*/	"RXOR",
	/* desc		*/	"Rx Overrun",
	/* mask		*/	HPDI32_BSR_RX_OVERRUN,
	/* value	*/	_rxor_values,
	/* values	*/	ARRAY_ELEMENTS(_rxor_values)
	},
	{
	/* name		*/	"RXUR",
	/* desc		*/	"Rx Under Run",
	/* mask		*/	HPDI32_BSR_RX_UNDER_RUN,
	/* value	*/	_rxur_values,
	/* values	*/	ARRAY_ELEMENTS(_rxur_values)
	},
	{
	/* name		*/	"TXOR",
	/* desc		*/	"Tx Overrun",
	/* mask		*/	HPDI32_BSR_TX_OVERRUN,
	/* value	*/	_txor_values,
	/* values	*/	ARRAY_ELEMENTS(_txor_values)
	},
	{
	/* name		*/	"RES",
	/* desc		*/	"Reserved",
	/* mask		*/	0x00180000,
	/* value	*/	NULL,
	/* values	*/	0
	},
	{
	/* name		*/	"PECL",
	/* desc		*/	"PECL Transcievers",
	/* mask		*/	HPDI32_BSR_PECL,
	/* value	*/	_pecl_values,
	/* values	*/	ARRAY_ELEMENTS(_pecl_values)
	},
	{
	/* name		*/	"BJ1",
	/* desc		*/	"Board Jumper 1",
	/* mask		*/	HPDI32_BSR_BJ1,
	/* value	*/	_bj1_values,
	/* values	*/	ARRAY_ELEMENTS(_bj1_values)
	},
	{
	/* name		*/	"BJ0",
	/* desc		*/	"Board Jumper 0",
	/* mask		*/	HPDI32_BSR_BJ0,
	/* value	*/	_bj0_values,
	/* values	*/	ARRAY_ELEMENTS(_bj0_values)
	},
	{
	/* name		*/	"RXFIFO",
	/* desc		*/	"Rx FIFO Status",
	/* mask		*/	HPDI32_BSR_RX_MASK,
	/* value	*/	_rx_fifo_values,
	/* values	*/	ARRAY_ELEMENTS(_rx_fifo_values)
	},
	{
	/* name		*/	"RXF",
	/* desc		*/	"Rx FULL",
	/* mask		*/	HPDI32_BSR_RX_NOT_FULL,
	/* value	*/	_rxf_values,
	/* values	*/	ARRAY_ELEMENTS(_rxf_values)
	},
	{
	/* name		*/	"RXAF",
	/* desc		*/	"Rx Almost Full",
	/* mask		*/	HPDI32_BSR_RX_NOT_AF,
	/* value	*/	_rxaf_values,
	/* values	*/	ARRAY_ELEMENTS(_rxaf_values)
	},
	{
	/* name		*/	"RXAE",
	/* desc		*/	"Rx Almost Empty",
	/* mask		*/	HPDI32_BSR_RX_NOT_AE,
	/* value	*/	_rxae_values,
	/* values	*/	ARRAY_ELEMENTS(_rxae_values)
	},
	{
	/* name		*/	"RXE",
	/* desc		*/	"Rx Empty",
	/* mask		*/	HPDI32_BSR_RX_NOT_EMPTY,
	/* value	*/	_rxe_values,
	/* values	*/	ARRAY_ELEMENTS(_rxe_values)
	},
	{
	/* name		*/	"TXFIFO",
	/* desc		*/	"Tx FIFO Status",
	/* mask		*/	HPDI32_BSR_TX_MASK,
	/* value	*/	_tx_fifo_values,
	/* values	*/	ARRAY_ELEMENTS(_tx_fifo_values)
	},
	{
	/* name		*/	"TXF",
	/* desc		*/	"Tx FULL",
	/* mask		*/	HPDI32_BSR_TX_NOT_FULL,
	/* value	*/	_txf_values,
	/* values	*/	ARRAY_ELEMENTS(_txf_values)
	},
	{
	/* name		*/	"TXAF",
	/* desc		*/	"Tx Almost Full",
	/* mask		*/	HPDI32_BSR_TX_NOT_AF,
	/* value	*/	_txaf_values,
	/* values	*/	ARRAY_ELEMENTS(_txaf_values)
	},
	{
	/* name		*/	"TXAE",
	/* desc		*/	"Tx Almost Empty",
	/* mask		*/	HPDI32_BSR_TX_NOT_AE,
	/* value	*/	_txae_values,
	/* values	*/	ARRAY_ELEMENTS(_txae_values)
	},
	{
	/* name		*/	"TXE",
	/* desc		*/	"Tx Empty",
	/* mask		*/	HPDI32_BSR_TX_NOT_EMPTY,
	/* value	*/	_txe_values,
	/* values	*/	ARRAY_ELEMENTS(_txe_values)
	},
	{
	/* name		*/	"TXA",
	/* desc		*/	"Tx Active",
	/* mask		*/	HPDI32_BSR_TX_ACTIVE,
	/* value	*/	_txa_values,
	/* values	*/	ARRAY_ELEMENTS(_txa_values)
	},
	{
	/* name		*/	"D6",
	/* desc		*/	"Cable Signal D6",
	/* mask		*/	HPDI32_BSR_D6,
	/* value	*/	_d6_values,
	/* values	*/	ARRAY_ELEMENTS(_d6_values)
	},
	{
	/* name		*/	"D5",
	/* desc		*/	"Cable Signal D5",
	/* mask		*/	HPDI32_BSR_D5,
	/* value	*/	_d5_values,
	/* values	*/	ARRAY_ELEMENTS(_d5_values)
	},
	{
	/* name		*/	"D4",
	/* desc		*/	"Cable Signal D4",
	/* mask		*/	HPDI32_BSR_D4,
	/* value	*/	_d4_values,
	/* values	*/	ARRAY_ELEMENTS(_d4_values)
	},
	{
	/* name		*/	"D3",
	/* desc		*/	"Cable Signal D3",
	/* mask		*/	HPDI32_BSR_D3,
	/* value	*/	_d3_values,
	/* values	*/	ARRAY_ELEMENTS(_d3_values)
	},
	{
	/* name		*/	"D2",
	/* desc		*/	"Cable Signal D2",
	/* mask		*/	HPDI32_BSR_D2,
	/* value	*/	_d2_values,
	/* values	*/	ARRAY_ELEMENTS(_d2_values)
	},
	{
	/* name		*/	"D1",
	/* desc		*/	"Cable Signal D1",
	/* mask		*/	HPDI32_BSR_D1,
	/* value	*/	_d1_values,
	/* values	*/	ARRAY_ELEMENTS(_d1_values)
	},
	{
	/* name		*/	"D0",
	/* desc		*/	"Cable Signal D0",
	/* mask		*/	HPDI32_BSR_D0,
	/* value	*/	_d0_values,
	/* values	*/	ARRAY_ELEMENTS(_d0_values)
	}
} ;

reg_def_t	reg_fw_bsr	=
{
	/* name			*/	"BSR",
	/* desc			*/	"Board Status Register",
	/* reg_id		*/	HPDI32_BSR,
	/* read_only	*/	0xFFFFFFFF,
	/* field		*/	_bsr_fields,
	/* fields		*/	ARRAY_ELEMENTS(_bsr_fields),
	/* init			*/	NULL,
	/* refresh		*/	NULL
};


