// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/regs_fw_icr.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

/*****************************************************************************
*
*	Provide data describing the Interrupt Control Register.
*
*****************************************************************************/

#include "regs.h"



/* variables	*************************************************************/

static const reg_value_t	_c0a_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C0A_
	}
};

static const reg_value_t	_c0i_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C0I_
	}
};

static const reg_value_t	_c1_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C1_
	}
};

static const reg_value_t	_c2_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C2_
	}
};

static const reg_value_t	_c3_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C3_
	}
};

static const reg_value_t	_c4_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C4_
	}
};

static const reg_value_t	_c5_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C5_
	}
};

static const reg_value_t	_c6_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_C6_
	}
};

static const reg_value_t	_tfe_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_TX_E
	}
};

static const reg_value_t	_tfae_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_TX_AE
	}
};

static const reg_value_t	_tfaf_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_TX_AF
	}
};

static const reg_value_t	_tff_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_TX_F
	}
};

static const reg_value_t	_rfe_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_RX_E
	}
};

static const reg_value_t	_rfae_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_RX_AE
	}
};

static const reg_value_t	_rfaf_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_RX_AF
	}
};

static const reg_value_t	_rff_values[]	=
{
	{
	/* name		*/	"Disable",
	/* value	*/	0
	},
	{
	/* name		*/	"Enable",
	/* value	*/	HPDI32_IRQ_RX_F
	}
};


static reg_field_t	_fields[]	=
{
	{
	/* name		*/	"RES",
	/* desc		*/	"Reserved",
	/* mask		*/	0xFFFF0000,
	/* value	*/	NULL,
	/* values	*/	0
	},
	{
	/* name		*/	"RFF",
	/* desc		*/	"Rx FIFO Full",
	/* mask		*/	HPDI32_IRQ_RX_F,
	/* value	*/	_rff_values,
	/* values	*/	ARRAY_ELEMENTS(_rff_values)
	},
	{
	/* name		*/	"RFAF",
	/* desc		*/	"Rx FIFO Almost Full",
	/* mask		*/	HPDI32_IRQ_RX_AF,
	/* value	*/	_rfaf_values,
	/* values	*/	ARRAY_ELEMENTS(_rfaf_values)
	},
	{
	/* name		*/	"RFAE",
	/* desc		*/	"Rx FIFO Almost Empty",
	/* mask		*/	HPDI32_IRQ_RX_AE,
	/* value	*/	_rfae_values,
	/* values	*/	ARRAY_ELEMENTS(_rfae_values)
	},
	{
	/* name		*/	"RFE",
	/* desc		*/	"Rx FIFO Empty",
	/* mask		*/	HPDI32_IRQ_RX_E,
	/* value	*/	_rfe_values,
	/* values	*/	ARRAY_ELEMENTS(_rfe_values)
	},
	{
	/* name		*/	"TFF",
	/* desc		*/	"Tx FIFO Full",
	/* mask		*/	HPDI32_IRQ_TX_F,
	/* value	*/	_tff_values,
	/* values	*/	ARRAY_ELEMENTS(_tff_values)
	},
	{
	/* name		*/	"TFAF",
	/* desc		*/	"Tx FIFO Almost Full",
	/* mask		*/	HPDI32_IRQ_TX_AF,
	/* value	*/	_tfaf_values,
	/* values	*/	ARRAY_ELEMENTS(_tfaf_values)
	},
	{
	/* name		*/	"TFAE",
	/* desc		*/	"Tx FIFO Almost Empty",
	/* mask		*/	HPDI32_IRQ_TX_AE,
	/* value	*/	_tfae_values,
	/* values	*/	ARRAY_ELEMENTS(_tfae_values)
	},
	{
	/* name		*/	"TFE",
	/* desc		*/	"Tx FIFO Empty",
	/* mask		*/	HPDI32_IRQ_TX_E,
	/* value	*/	_tfe_values,
	/* values	*/	ARRAY_ELEMENTS(_tfe_values)
	},
	{
	/* name		*/	"C6",
	/* desc		*/	"Cable Command 6: Rx Enabled, GPIO 5",
	/* mask		*/	HPDI32_IRQ_C6_,
	/* value	*/	_c6_values,
	/* values	*/	ARRAY_ELEMENTS(_c6_values)
	},
	{
	/* name		*/	"C5",
	/* desc		*/	"Cable Command 5: Tx Enabled, GPIO 4",
	/* mask		*/	HPDI32_IRQ_C5_,
	/* value	*/	_c5_values,
	/* values	*/	ARRAY_ELEMENTS(_c5_values)
	},
	{
	/* name		*/	"C4",
	/* desc		*/	"Cable Command 4: Tx Data Ready, GPIO 3",
	/* mask		*/	HPDI32_IRQ_C4_,
	/* value	*/	_c4_values,
	/* values	*/	ARRAY_ELEMENTS(_c4_values)
	},
	{
	/* name		*/	"C3",
	/* desc		*/	"Cable Command 3: Rx Ready, GPIO 2",
	/* mask		*/	HPDI32_IRQ_C3_,
	/* value	*/	_c3_values,
	/* values	*/	ARRAY_ELEMENTS(_c3_values)
	},
	{
	/* name		*/	"C2",
	/* desc		*/	"Cable Command 2: Status Valid, GPIO 1",
	/* mask		*/	HPDI32_IRQ_C2_,
	/* value	*/	_c2_values,
	/* values	*/	ARRAY_ELEMENTS(_c2_values)
	},
	{
	/* name		*/	"C1",
	/* desc		*/	"Cable Command 1: Line Valid, GPIO 0",
	/* mask		*/	HPDI32_IRQ_C1_,
	/* value	*/	_c1_values,
	/* values	*/	ARRAY_ELEMENTS(_c1_values)
	},
	{
	/* name		*/	"C0I",
	/* desc		*/	"Cable Command 0: Frame Valid, GPIO 6 (default: Falling Edge)",
	/* mask		*/	HPDI32_IRQ_C0I_,
	/* value	*/	_c0i_values,
	/* values	*/	ARRAY_ELEMENTS(_c0i_values)
	},
	{
	/* name		*/	"C0A",
	/* desc		*/	"Cable Command 0: Frame Valid, GPIO 6 (default: Rising Edge)",
	/* mask		*/	HPDI32_IRQ_C0A_,
	/* value	*/	_c0a_values,
	/* values	*/	ARRAY_ELEMENTS(_c0a_values)
	}
};

reg_def_t	reg_fw_icr	=
{
	/* name			*/	"ICR",
	/* desc			*/	"Interrupt Control Register",
	/* reg_id		*/	HPDI32_ICR,
	/* read_only	*/	0xFFFF0000,
	/* field		*/	_fields,
	/* fields		*/	ARRAY_ELEMENTS(_fields),
	/* init			*/	NULL,
	/* refresh		*/	NULL
};


