// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/regs_fw_rar.c $
// $Rev: 2809 $
// $Date: 2009-07-29 21:26:35 -0500 (Wed, 29 Jul 2009) $

/*****************************************************************************
*
*	Provide data describing the Rx Almost Register.
*
*****************************************************************************/

#include "regs.h"



/* variables	*************************************************************/

static const reg_value_t	_ae_values[]	=
{
	{
	/* name		*/	"Default",
	/* value	*/	HPDI32_RAR_AE_DEFAULT
	},
	{
	/* name		*/	"Maximum",
	/* value	*/	HPDI32_RAR_AE
	}
};

static const reg_value_t	_af_values[]	=
{
	{
	/* name		*/	"Default",
	/* value	*/	HPDI32_RAR_AF_DEFAULT
	},
	{
	/* name		*/	"Maximum",
	/* value	*/	HPDI32_RAR_AF
	}
};

static reg_field_t	_fields[]	=
{
	{
	/* name		*/	"AF",
	/* desc		*/	"Almost Full Level",
	/* mask		*/	HPDI32_RAR_AF,
	/* value	*/	_af_values,
	/* values	*/	ARRAY_ELEMENTS(_af_values)
	},
	{
	/* name		*/	"AE",
	/* desc		*/	"Almost Empty Level",
	/* mask		*/	HPDI32_RAR_AE,
	/* value	*/	_ae_values,
	/* values	*/	ARRAY_ELEMENTS(_ae_values)
	}
} ;

reg_def_t	reg_fw_rar	=
{
	/* name			*/	"RAR",
	/* desc			*/	"Rx Almost Register",
	/* reg_id		*/	HPDI32_RAR,
	/* read_only	*/	FALSE,
	/* field		*/	_fields,
	/* fields		*/	ARRAY_ELEMENTS(_fields),
	/* init			*/	NULL,
	/* refresh		*/	NULL
};


