// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/service.h $
// $Rev: 2902 $
// $Date: 2009-08-09 17:48:49 -0500 (Sun, 09 Aug 2009) $

/*****************************************************************************
*
*	Export the common service mechanism. This is intended primarily for
*	control and menu item access.
*
*****************************************************************************/

#ifndef __SERVICE_H__
#define	__SERVICE_H__

#include "visual.h"		/*lint !e537 */



/* typedefs	*****************************************************************/

typedef enum
{
	SERVICE_DEVICE_CLOSE,
	SERVICE_DEVICE_OPEN,
	SERVICE_END_LIST,			// Terminates a list.
	SERVICE_INIT,
	SERVICE_REFRESH,
	SERVICE_WM_CTLCOLORSTATIC,	// arg1 = wParam, arg2 = lParam
	SERVICE_WM_COMMAND			// arg1 = wParam, arg2 = lParam
} service_type_t;

typedef struct
{
	service_type_t	service;
	LRESULT			(*function)(HWND			dlg,
								device_t*		device,
								WPARAM			wParam,
								LPARAM			lParam);
} service_call_t;

typedef struct
{
	LRESULT	(*function)(HWND			dlg,
						device_t*		device,
						service_type_t	service,
						WPARAM			wParam,
						LPARAM			lParam);
} service_item_t;



/* prototypes	*************************************************************/

LRESULT	service_call(	HWND					dlg,
						device_t*				device,
						const service_call_t*	list,
						service_type_t			service,
						WPARAM			wParam,
						LPARAM			lParam);

void	service_list(	HWND					dlg,
						device_t*				device,
						const service_item_t*	list,
						service_type_t			service,
						WPARAM			wParam,
						LPARAM			lParam);



#endif
