// HPDI32 - Application - Win32 - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/visualhpdi32/win32/util_ctrl.h $
// $Rev: 31452 $
// $Date: 2014-11-13 09:58:59 -0600 (Thu, 13 Nov 2014) $

/*****************************************************************************
*
*	Export items for various utility service for window controls.
*
*****************************************************************************/

#ifndef __UTIL_CTRL_H__
#define	__UTIL_CTRL_H__

#include "visual.h"		/*lint !e537 */



/* #defines	*****************************************************************/

#define	CTRL_ENABLE		0x0001
#define	CTRL_DISABLE	0x0002
#define	CTRL_BM_CHECK	0x0004
#define	CTRL_BM_UNCHECK	0x0008
#define	CTRL_NULL		0x0010	// An empty string.
#define	CTRL_LB_RESET	0x0020
#define	CTRL_FOCUS		0x0040
#define	CTRL_DELETE		0x0080



/* typedefs	*****************************************************************/

typedef struct
{
	int	ctrl_id;
	U32	u32;
} ctrl_id_u32_t;



/* prototypes	*************************************************************/

U32		ctrl_hex_2_u32(HWND dlg, int ctrl_id, U32* u32);
void	ctrl_menu_set(HWND dlg, int id, unsigned int flags);
void	ctrl_menu_set_text(HWND dlg, int id, const char* text);
U32		ctrl_radio_2_u32(HWND dlg, const ctrl_id_u32_t* list, size_t size, U32 defalt);
U32		ctrl_text_2_u32(HWND dlg, int ctrl_id, int k, U32* u32);
void	ctrl_u32_2_radio(HWND dlg, U32 u32, const ctrl_id_u32_t* list, size_t size);



#endif
