// HPDI32 - Application - Any OS - Any Compiler
// $URL: http://subversion:8080/svn/gsc/trunk/drivers/SDK/hpdi32/xfer/main.h $
// $Rev: 31049 $
// $Date: 2014-10-27 17:49:58 -0500 (Mon, 27 Oct 2014) $

#ifndef __MAIN_H__
#define __MAIN_H__

#include "hpdi32.h"



/* #defines	*****************************************************************/

#define	VERSION				"1.5"
// 1.5	Added forced delay in Tx code before checking FIFO Status.
// 1.4	We now wait for the Tx FIFO to empty before we finish.
// 1.03	Ported to Microsoft Visual Studio 2005
//		Ported to 64-bit Windows.
//		Renamed hpdi32_api.* hpdi32.*.
// 1.02	Added host os identification.
// 1.01	Ported to the SDK.
// 1.00	Initial release.

#define	ARRAY_ELEMENTS(a)			(sizeof((a))/sizeof((a)[0]))

#define	BLOCK_COUNT_LIMIT			(100L * 1024L * 1024L)
#define	BLOCK_SAMPLES_LIMIT			(10L * 1024L * 1024L)

#define	TRANSFER_PERIOD_LIMIT_DAYS	7

#define	SECONDS_PER_YEAR	(60L * 60 * 24 * 7 * 52)
#define	SECONDS_PER_WEEK	(60L * 60 * 24 * 7)
#define	SECONDS_PER_DAY		(60L * 60 * 24)
#define	SECONDS_PER_HOUR	(60L * 60)
#define	SECONDS_PER_MINUTE	(60L)

#if defined(WIN32)
	#if (_MSC_VER >= 1400)	// Visual Studio 2005 or later
		#define	stricmp	_stricmp
	#endif
#endif



/* variables	*************************************************************/

extern	U32	block_count;
extern	U32	block_samples;
extern	U32	io_clock;



/* prototypes	*************************************************************/

void	actual_duration(long begin);
U32		estimate_duration(U32 clock, U32 size, double bytes);
void	format_value(U32 u32, const char* units);
U32		my_mem_alloc(void* device, U32 which, U32 size, void** ptr);
void	my_mem_free(void* device, U32 which);
U32		read_config_file(void* device, const char* name);
U32		rx_process(void* device);
U32		show_data_rate(U32 which, U32 clock, U32 size);
U32		show_data_set(void* device, U32 which, unsigned long* size, double* bytes);
U32		test_status(U32 status, const char* service);
U32		tx_process(void* device);
U32		tx_rx_tristate(void* device);



#endif
